#ifndef APPLICATION_H
#define APPLICATION_H

#include <string>
#include "acframe_application.h"

class CSceneMgr;
class CGameMgr;
class CScriptMgr;
class CConsole;
class CGuiMgr;
class CPhysicsMgr;
class CPathMgr;
class CRecorder;

class CGameApplication : public acFramework::CApplication
{
public:
	CGameApplication();
	~CGameApplication();

	int  Init(acUtility::CConfig &cfg);
	void Uninit();
	void Step();
	void Render();
	void Quit();

	void InitPlay();

	CSceneMgr           *sceneMgr;
	CGameMgr            *gameMgr;
	CScriptMgr          *scriptMgr;
	CConsole            *console;
	CGuiMgr             *guiMgr;
	CPhysicsMgr         *physicsMgr;
	CPathMgr            *pathMgr;
	CRecorder           *recorder;

	bool successfulInit;
	bool drawPhysics;
	bool recording;
	bool playback;

protected:
	friend class CConsole;

	int InitOptional(acUtility::CConfig &cfg);

	std::string screenshotFolder;

	float remainingTime;
};

extern CGameApplication *app;

#endif