#ifndef CONSOLE_H
#define CONSOLE_H

#include <string>
#include <vector>

namespace acGraphics
{
	class CFont;
}

// TODO: This class might be a good candidate for the toolbox library 
//       if we can keep the application specific stuff out of it

class CConsole
{
public:
	CConsole();
	~CConsole();

	int Init();
	void Uninit();

	// Returns true if the console is open
	bool Frame();
	void Render();

	void WriteLine(const char *text);
	void WriteMultipleLines(const char *text);

	void Show();
	void Hide();
	bool IsTakingInput();

protected:
	void DisplayStatistics();
	void DisplayLines();
	bool ExecuteCommand(std::string &cmd);


	acGraphics::CFont *font;

	int currentLine;
	float visibleLines;
	std::vector<std::string> lines;

	std::string inputString;

	bool takeInput;

	bool showStats;
	bool showFps;
};

#endif