#ifndef GAMEGROUP_H
#define GAMEGROUP_H

#include <vector>
#include <string>
#include "acutil_math.h"

class CSprite;
class CPhysicsObject;
class CGameObjectLink;

class CGameGroup
{
public:
	CGameGroup();
	~CGameGroup();

	void SetPosition(const acUtility::vector2 &pos);
	acUtility::vector2 GetPosition();
	void SetVelocity(const acUtility::vector2 &vel);
	acUtility::vector2 GetVelocity();
	void SynchSceneAndPhysics();

	void SetAnchor(CGameObjectLink *anchor);
	void AddBlocker(CPhysicsObject *blk);
	void AddSprite(CSprite *spr);
	void AddObject(CGameObjectLink *obj);

	std::string         name;

protected:
	friend class CGameMgr;

	acUtility::vector2  position;

	std::vector<CSprite*>           sprites;
	std::vector<acUtility::vector2> spriteOffsets;
	std::vector<CPhysicsObject*>    blockers;
	std::vector<acUtility::vector2> blockerOffsets;
	std::vector<CGameObjectLink*>   objects;
	std::vector<acUtility::vector2> objectOffsets;

	CGameObjectLink    *anchor;
	acUtility::vector2  anchorOffset;
};

#endif