#ifndef GAMEOBJFACTORY_H
#define GAMEOBJFACTORY_H

#include <string>
#include "acutil_math.h"
#include <vector>
#include "physicsmgr.h"

class CGameObject;
class CSpriteAnimation;
struct SEntityController;

namespace acUtility
{
	class CSoundBuffer;
}

class CGameObjectFactory
{
public:
	CGameObjectFactory();
	~CGameObjectFactory();

	int               Load(const char *type);
	CGameObject      *CreateObject(const acUtility::vector2 &pos);
	CSpriteAnimation *GetAnimation(const char *anim);

	std::string                    typeName;
	std::string				       sprite;
	acUtility::vector2             size;
	acUtility::vector2             offset;
	SEntityController             *scriptType;
	std::vector<CSpriteAnimation*> animations;
	// TODO: Should use a structure
	int                            collisionShapeType;
	acUtility::vector2             collisionHalfSize;
	bool                           collisionFixedRotation;
	float                          weight;
	EPhysicsProperty               collisionProperty;
	acUtility::CSoundBuffer       *collisionSound;
	bool                           groupAnchor;
};

#endif