#ifndef GENERATOR_H
#define GENERATOR_H

#include <string>
#include <vector>
#include <acutil_rand.h>

class CGenerator
{
public:
	CGenerator();
	~CGenerator();

	int Generate(const std::string &script);

	void SetMapSize(unsigned int width, unsigned int height);
	void FillRect(unsigned int x, unsigned int y, unsigned int w, unsigned int h, char value);
	char &At(unsigned int x, unsigned int y);
	void AddObject(const std::string &type, float x, float y, int zOrder, const std::vector<std::string> &nameValuePairs); 
	float GetRandomNbr();

protected:
	void Finalize();

	acUtility::CSimpleRandomizer rand;

	char        *grid;
	unsigned int width;
	unsigned int height;
};

#endif