#include "guilistbox.h"
#include "application.h"
#include "guimgr.h"
#include "acgfx_graphics.h"
#include "acgfx_font.h"

using namespace acUtility;
using namespace std;

CGuiListBox::CGuiListBox(const vector2 &pos, const vector2 &size) : CGuiElement(pos, size)
{
}

CGuiListBox::~CGuiListBox()
{
}

void CGuiListBox::DrawSelf()
{
	// Draw the background rectangle
	app->guiMgr->DrawRect(vector2(0,0), size, srcImageIndex, srcBottomLeft, srcTopRight);

	int line = GetMouseOverItem();

	// Draw each list element
	float y = size.y;
	float height = app->guiMgr->GetFont(fontIndex)->GetHeight() * 1.1f;
	for( unsigned int n = 0; n < items.size(); n++ )
	{
		y -= height;
		if( line == n )
		{
			// TODO: The mouse over effect should be scriptable
			float h = app->guiMgr->GetFont(fontIndex)->GetHeight();
			app->guiMgr->GetFont(fontIndex)->SetHeight(h*1.1f);
			app->guiMgr->DrawText(vector2(5,y), items[n], fontIndex, acGraphics::FONT_ALIGN_LEFT, 0xFFFFFFFF);
			app->guiMgr->GetFont(fontIndex)->SetHeight(h);
		}
		else
			app->guiMgr->DrawText(vector2(5,y), items[n], fontIndex, acGraphics::FONT_ALIGN_LEFT, 0xFFFFFFFF);
	}

	// TODO: Draw slider
}

int CGuiListBox::GetMouseOverItem()
{
	// TODO: Transform the mouse position to the window coordinates even if the window is a child window
	vector2 pos = app->guiMgr->GetMousePos();
	pos -= position;

	if( pos.x < 0 || pos.x > size.x || pos.y < 0 || pos.y > size.y )
		return -1;

	// Determine the line
	float height = app->guiMgr->GetFont(fontIndex)->GetHeight() * 1.1f;
	
	int line = int((size.y - pos.y)/height);

	if( line >= int(items.size()) )
		return -1;

	return line;
}

void CGuiListBox::AddItem(const string &text)
{
	items.push_back(text);
}

string CGuiListBox::GetItem(unsigned int i)
{
	if( i < items.size() )
		return items[i];

	return "";
}