#include "material.h"
#include "acutil_log.h"
#include "acgfx_graphics.h"
#include "acutil_config.h"
#include "acutil_filemgr.h"
#include "application.h"
#include "scenemgr.h"

using namespace acUtility;
using namespace acGraphics;
using namespace std;

CMaterial::CMaterial()
{
	colorMap = 0;
	flipX    = false;
	color    = 0xFFFFFFFF;
}

CMaterial::~CMaterial()
{
}

int CMaterial::Load(const string &materialName)
{
	name = materialName;

	if( name.length() > 4 && _stricmp(name.substr(name.length()-4).c_str(), ".mat") == 0 )
	{
		string p = app->fileMgr->GetPathForFile(materialName.c_str());
		CConfig cfg;
		int r = cfg.LoadConfigFile(p.c_str());
		if( r >= 0 )
		{
			// Get color texture
			string colorTex;
			if( cfg.GetAttrAsString("image", colorTex) )
			{
				colorMap = app->sceneMgr->GetSharedTexture(colorTex.c_str());
			}

			cfg.GetAttrAsBool("flipX", flipX, 0, false);
			cfg.GetAttrAsInt("color", (int&)color, 0, 0xFFFFFF);
			color |= 0xFF000000;
		}
	}
	else
	{
		// Load the image file directly as the material file
		colorMap = app->sceneMgr->GetSharedTexture(name.c_str());
	}

	return 0;
}