#ifndef PATHEDGE_H
#define PATHEDGE_H

#include "acutil_math.h"

class CPathNode;

class CPathEdge
{
public:
	CPathEdge(acUtility::vector2 &v1, acUtility::vector2 &v2, CPathNode *owner);

	CPathEdge         *Split(acUtility::vector2 &v);
	void               SetNeighbour(CPathEdge *n);
	void               SetNext(CPathEdge *n);
	acUtility::vector2 GetNormal();

	bool               FindWallCornerBefore(acUtility::vector2 *p);
	bool               FindWallCornerAfter(acUtility::vector2 *p);

	CPathEdge *next;
	CPathEdge *prev;
	acUtility::vector2 p1;
	acUtility::vector2 p2;
	bool wall;

	CPathNode *owner;
	CPathEdge *neighbour;
};

#endif