#ifndef PHYSICSOBJECT_H
#define PHYSICSOBJECT_H

#include "acutil_math.h"

class CGameObjectLink;
class CGameGroup;
class b2Body;

class CPhysicsObject
{
public:
	CGameObjectLink *m_link;
	CGameGroup      *m_group;

	void SetPosition(const acUtility::vector2 &pos);
	acUtility::vector2 GetPosition() const;
	void SetVelocity(const acUtility::vector2 &vel);
	acUtility::vector2 GetVelocity() const;
	void SetRotation(float rot);
	float GetRotation() const;

	void SetCollision(bool collision);
	void SetCustomGravity(const acUtility::vector2 &gravity);
	void ClearCustomGravity();
	void SetFixedRotation(bool fixed);

protected:
	friend class CPhysicsMgr;

	CPhysicsObject();
	~CPhysicsObject();

	b2Body            *m_body;
	acUtility::vector2 m_gravity;
	bool               m_useCustomGravity;
};

#endif